use thiserror::Error;

use crate::response::APIError;

#[derive(Error, Debug)]
pub enum Error {
    #[error("error parsing result: {0}")]
    Parse(serde_json::Error),
    #[error("invalid request: {0}")]
    Request(Box<dyn core::error::Error>),
    #[error("connection error: {0}")]
    Response(Box<dyn core::error::Error>),
    #[error("api responded with error: {0}")]
    Api(APIError),
}

impl From<serde_json::Error> for Error {
    fn from(value: serde_json::Error) -> Self {
        Self::Parse(value)
    }
}
